use crate::mathml_renderer::attribute::RowAttr;

static COLORS: phf::Map<&'static str, RowAttr> = phf::phf_map! {
    // RGB
    "red" => RowAttr::Color(255, 0, 0),
    "green" => RowAttr::Color(3, 255, 0),
    "blue" => RowAttr::Color(0, 0, 255),
    // CMYK (sRGB approximation)
    "cyan" => RowAttr::Color(0, 185, 242),
    "magenta" => RowAttr::Color(251, 49, 153),
    "yellow" => RowAttr::Color(255, 235, 61),
    "black" => RowAttr::Color(0, 0, 0),
    // Grayscale
    "gray" => RowAttr::Color(128, 128, 128),
    "white" => RowAttr::Color(255, 255, 255),
    "darkgray" => RowAttr::Color(64, 64, 64),
    "lightgray" => RowAttr::Color(191, 191, 191),
    // Other
    "brown" => RowAttr::Color(191, 128, 63),
    "lime" => RowAttr::Color(191, 255, 4),
    "olive" => RowAttr::Color(159, 140, 24),
    "orange" => RowAttr::Color(255, 128, 1),
    "pink" => RowAttr::Color(255, 191, 191),
    "purple" => RowAttr::Color(191, 1, 64),
    "teal" => RowAttr::Color(0, 128, 128),
    "violet" => RowAttr::Color(128, 0, 128),
    // dvipsnames
    "Apricot" => RowAttr::Color(255, 184, 130),
    "Aquamarine" => RowAttr::Color(28, 191, 193),
    "Bittersweet" => RowAttr::Color(208, 76, 23),
    "Black" => RowAttr::Color(44, 46, 53),
    "Blue" => RowAttr::Color(16, 38, 148),
    "BlueGreen" => RowAttr::Color(20, 188, 188),
    "BlueViolet" => RowAttr::Color(45, 52, 151),
    "BrickRed" => RowAttr::Color(196, 49, 25),
    "Brown" => RowAttr::Color(119, 34, 6),
    "BurntOrange" => RowAttr::Color(255, 142, 39),
    "CadetBlue" => RowAttr::Color(99, 114, 157),
    "CarnationPink" => RowAttr::Color(252, 129, 188),
    "Cerulean" => RowAttr::Color(0, 173, 231),
    "CornflowerBlue" => RowAttr::Color(72, 187, 232),
    "Cyan" => RowAttr::Color(0, 185, 242),
    "Dandelion" => RowAttr::Color(255, 185, 76),
    "DarkOrchid" => RowAttr::Color(158, 80, 143),
    "Emerald" => RowAttr::Color(0, 177, 160),
    "ForestGreen" => RowAttr::Color(18, 159, 87),
    "Fuchsia" => RowAttr::Color(131, 55, 148),
    "Goldenrod" => RowAttr::Color(255, 219, 87),
    "Gray" => RowAttr::Color(155, 156, 159),
    "Green" => RowAttr::Color(0, 171, 79),
    "GreenYellow" => RowAttr::Color(225, 229, 123),
    "JungleGreen" => RowAttr::Color(0, 177, 157),
    "Lavender" => RowAttr::Color(253, 160, 204),
    "LimeGreen" => RowAttr::Color(136, 201, 70),
    "Magenta" => RowAttr::Color(251, 49, 153),
    "Mahogany" => RowAttr::Color(180, 50, 30),
    "Maroon" => RowAttr::Color(186, 49, 50),
    "Melon" => RowAttr::Color(255, 157, 123),
    "MidnightBlue" => RowAttr::Color(0, 104, 150),
    "Mulberry" => RowAttr::Color(168, 62, 158),
    "NavyBlue" => RowAttr::Color(8, 111, 189),
    "OliveGreen" => RowAttr::Color(63, 126, 49),
    "Orange" => RowAttr::Color(255, 124, 55),
    "OrangeRed" => RowAttr::Color(255, 46, 88),
    "Orchid" => RowAttr::Color(172, 114, 185),
    "Peach" => RowAttr::Color(255, 147, 88),
    "Periwinkle" => RowAttr::Color(106, 122, 191),
    "PineGreen" => RowAttr::Color(5, 141, 116),
    "Plum" => RowAttr::Color(135, 41, 150),
    "ProcessBlue" => RowAttr::Color(0, 187, 242),
    "Purple" => RowAttr::Color(143, 69, 163),
    "RawSienna" => RowAttr::Color(158, 60, 14),
    "Red" => RowAttr::Color(255, 46, 23),
    "RedOrange" => RowAttr::Color(255, 92, 49),
    "RedViolet" => RowAttr::Color(168, 44, 114),
    "Rhodamine" => RowAttr::Color(252, 88, 170),
    "RoyalBlue" => RowAttr::Color(0, 115, 192),
    "RoyalPurple" => RowAttr::Color(72, 57, 158),
    "RubineRed" => RowAttr::Color(253, 48, 136),
    "Salmon" => RowAttr::Color(255, 144, 138),
    "SeaGreen" => RowAttr::Color(71, 196, 160),
    "Sepia" => RowAttr::Color(93, 22, 1),
    "SkyBlue" => RowAttr::Color(80, 207, 226),
    "SpringGreen" => RowAttr::Color(196, 220, 110),
    "Tan" => RowAttr::Color(225, 157, 117),
    "TealBlue" => RowAttr::Color(17, 184, 184),
    "Thistle" => RowAttr::Color(222, 132, 191),
    "Turquoise" => RowAttr::Color(16, 190, 210),
    "Violet" => RowAttr::Color(61, 60, 159),
    "VioletRed" => RowAttr::Color(252, 90, 171),
    "White" => RowAttr::Color(255, 255, 255),
    "WildStrawberry" => RowAttr::Color(255, 55, 105),
    "Yellow" => RowAttr::Color(255, 235, 61),
    "YellowGreen" => RowAttr::Color(146, 208, 116),
    "YellowOrange" => RowAttr::Color(255, 159, 43),
};

pub fn get_color(name: &str) -> Option<RowAttr> {
    COLORS.get(name).copied()
}
